import os
from pathlib import Path

class FDlist():
    def __init__(self, tf_path, paths):
        r'''pass in any number of paths to fdlists as arguments
        '''
        self.__TF_PATH = tf_path
        self.__add, self.__remove = [], []
        for path in (path for path in paths if os.path.exists(path)):
            with open(path, "rt") as fdp:
                for line in fdp:
                    if line[0] == "-":
                        self.__remove.append(line[1:].strip("\n"))
                    else:
                        self.__add.append(line.strip("\n"))
                        
        self.__add = list(set(self.__add))
        asset_output = []
        for item in self.__add:
            if "*" not in item and (self.__TF_PATH / item).is_dir():
                for asset in list((self.__TF_PATH / item).glob("*")):
                    asset_output.append(asset)
                    
            elif "*" in item:
                counter = 0
                while True:
                    cval = Path(item).parents[counter]
                    if "*" not in str(cval):
                        for asset in list((self.__TF_PATH / cval).glob(str(Path(item).relative_to(cval)))):
                            asset_output.append(asset)
                        break
                    counter += 1
                    
            else:
                asset_output.append(item)
        self.__add = list(set(asset_output))

        self.__remove = list(set(self.__remove))
        asset_output = []
        for item in self.__remove:
            if "*" not in item and (self.__TF_PATH / item).is_dir():
                asset_output.append(item + "*")
            else:
                asset_output.append(item)
        
        self.__remove = list(set(asset_output))
        
    def get_lists(self):
        r'''returns the contents of FDlists as a pair of lists
        '''
        return self.__add.copy(), self.__remove.copy()
